diff --git a/gdb/testsuite/README b/gdb/testsuite/README
index 70f65cd..77ac74e 100644
--- a/gdb/testsuite/README
+++ b/gdb/testsuite/README
@@ -369,6 +369,9 @@ gdb,predefined_tsv
 
   The predefined trace state variables the board has.
 
+gdb,no_thread_names
+
+  The target doesn't support thread names.
 
 Testsuite Organization
 **********************
diff --git a/gdb/testsuite/gdb.threads/names.c b/gdb/testsuite/gdb.threads/names.c
new file mode 100644
index 0000000..6b08ff7
--- /dev/null
+++ b/gdb/testsuite/gdb.threads/names.c
@@ -0,0 +1,80 @@
+/* This testcase is part of GDB, the GNU debugger.
+
+   Copyright 2015 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include <unistd.h>
+#include <stdlib.h>
+#include <pthread.h>
+#include <assert.h>
+
+#define NUM_THREADS 3
+
+struct thread_data
+{
+  const char *name;
+  pthread_barrier_t *barrier;
+};
+
+static void *
+thread_func (void *varg)
+{
+  struct thread_data *arg = (struct thread_data *) varg;
+
+  pthread_setname_np (pthread_self (), arg->name);
+
+  pthread_barrier_wait (arg->barrier);
+
+  while (1)
+    sleep (1);
+}
+
+static void
+all_threads_ready (void)
+{
+}
+
+int
+main (int argc, char **argv)
+{
+  pthread_t threads[NUM_THREADS];
+  struct thread_data args[NUM_THREADS];
+  pthread_barrier_t barrier;
+  int i;
+  const char *names[] = { "carrot", "potato", "celery" };
+
+  /* Make sure that NAMES contains NUM_THREADS elements.  */
+  assert (sizeof (names) == sizeof(names[0]) * NUM_THREADS);
+
+  assert (0 == pthread_barrier_init (&barrier, NULL, NUM_THREADS + 1));
+
+  pthread_setname_np (pthread_self (), "main");
+
+  for (i = 0; i < NUM_THREADS; i++)
+    {
+      struct thread_data *arg = &args[i];
+
+      arg->name = names[i];
+      arg->barrier = &barrier;
+
+      assert (0 == pthread_create (&threads[i], NULL, thread_func, arg));
+    }
+
+  pthread_barrier_wait (&barrier);
+
+  all_threads_ready ();
+
+  return 0;
+}
diff --git a/gdb/testsuite/gdb.threads/names.exp b/gdb/testsuite/gdb.threads/names.exp
new file mode 100644
index 0000000..b056df3
--- /dev/null
+++ b/gdb/testsuite/gdb.threads/names.exp
@@ -0,0 +1,38 @@
+# Copyright (C) 2015 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Verify that thread name features work properly (e.g. they show up in info
+# threads).
+
+if [target_info exists gdb,no_thread_names] {
+  continue
+}
+
+standard_testfile
+
+if [prepare_for_testing "failed to prepare" $testfile $srcfile {debug pthreads}] {
+    return -1
+}
+
+if ![runto "all_threads_ready"] {
+    continue
+}
+
+set expected_thread_list "\\* 1   .*\"main\" all_threads_ready.*\n"
+append expected_thread_list "  2   .*\"carrot\".*\n"
+append expected_thread_list "  3   .*\"potato\".*\n"
+append expected_thread_list "  4   .*\"celery\".*"
+
+gdb_test "info threads" "$expected_thread_list" "list threads"